| CUTLASS CUDA Templates for Linear Algebra Subroutines and Solvers

- Main Page
- Modules
- Namespaces
- Classes
- Files

- Class List
- Class Index
- Class Hierarchy
- Class Members

Public Types | Public Member Functions | List of all members
cutlass::SubbyteReference< Element_, Storage_ > Class Template Reference

`#include <subbyte_reference.h>`

## Public Types
using | Element = Element_
using | Storage = Storage_
using | StoragePointer = Storage *

## Public Member Functions
CUTLASS_HOST_DEVICE | SubbyteReference ()
CUTLASS_HOST_DEVICE | SubbyteReference (Element *ptr, int64_t offset)
| Constructor. More...
CUTLASS_HOST_DEVICE | SubbyteReference (Element *ptr=nullptr)
| Constructor. More...
CUTLASS_HOST_DEVICE StoragePointer | storage_pointer () const
| Gets storage pointer. More...
CUTLASS_HOST_DEVICE int | element_offset () const
| Gets element offset within storage vector. More...
CUTLASS_HOST_DEVICE Element | get () const
| Unpacks an element from memory. More...
CUTLASS_HOST_DEVICE SubbyteReference & | set (Element const &x)
| Stores an element to memory. More...
CUTLASS_HOST_DEVICE | operator Element () const
| Unpacks an element from memory. More...
CUTLASS_HOST_DEVICE SubbyteReference & | operator= (Element const &x)
| Stores an element to memory. More...
CUTLASS_HOST_DEVICE SubbyteReference & | operator= (SubbyteReference const &x)
| Stores an element to memory. More...
CUTLASS_HOST_DEVICE SubbyteReference & | operator= (ConstSubbyteReference< Element, Storage > const &x)
| Stores an element to memory. More...
CUTLASS_HOST_DEVICE SubbyteReference & | operator+= (int offset)
| Adds an offset in units of elements to the reference. More...
CUTLASS_HOST_DEVICE SubbyteReference & | operator+= (long long offset)
| Adds an offset in units of elements to the reference. More...
CUTLASS_HOST_DEVICE SubbyteReference & | operator-= (int offset)
| Adds an offset in units of elements to the reference. More...
CUTLASS_HOST_DEVICE SubbyteReference & | operator-= (long long offset)
| Adds an offset in units of elements to the reference. More...
CUTLASS_HOST_DEVICE SubbyteReference | operator+ (int offset) const
| Returns a reference to an element with a given offset from the current reference. More...
CUTLASS_HOST_DEVICE SubbyteReference | operator+ (long long offset) const
| Returns a reference to an element with a given offset from the current reference. More...
CUTLASS_HOST_DEVICE SubbyteReference | operator- (int offset) const
| Returns a reference to an element with a given offset from the current reference. More...
CUTLASS_HOST_DEVICE SubbyteReference | operator-= (long long offset) const
| Returns a reference to an element with a given offset from the current reference. More...
CUTLASS_HOST_DEVICE ptrdiff_t | operator- (SubbyteReference ref) const
| Computes the difference in elements between references. More...
CUTLASS_HOST_DEVICE | operator int () const
| Explicit cast to int. More...
CUTLASS_HOST_DEVICE | operator int64_t () const
| Explicit cast to signed 64-bit integer. More...
CUTLASS_HOST_DEVICE | operator uint64_t () const
| Explicit cast to unsigned 64-bit integer. More...
CUTLASS_HOST_DEVICE | operator float () const
| Explicit cast to float. More...
CUTLASS_HOST_DEVICE | operator double () const
| Explicit cast to double. More...

## Member Typedef Documentation

template<typename Element_, typename Storage_ = uint8_t>

using cutlass::SubbyteReference< Element_, Storage_ >::Element = Element_

template<typename Element_, typename Storage_ = uint8_t>

using cutlass::SubbyteReference< Element_, Storage_ >::Storage = Storage_

template<typename Element_, typename Storage_ = uint8_t>

using cutlass::SubbyteReference< Element_, Storage_ >::StoragePointer = Storage *

## Constructor & Destructor Documentation

template<typename Element_, typename Storage_ = uint8_t>

CUTLASS_HOST_DEVICE cutlass::SubbyteReference< Element_, Storage_ >::SubbyteReference | ( |  | ) |
| inline

template<typename Element_, typename Storage_ = uint8_t>

CUTLASS_HOST_DEVICE cutlass::SubbyteReference< Element_, Storage_ >::SubbyteReference | ( | Element * | ptr,
|  | int64_t | offset
| ) |  |
| inline

Parameters

  offset | pointer to memory logical offset in units of Element

template<typename Element_, typename Storage_ = uint8_t>

CUTLASS_HOST_DEVICE cutlass::SubbyteReference< Element_, Storage_ >::SubbyteReference | ( | Element * | ptr = `nullptr` | ) |
| inline

## Member Function Documentation

template<typename Element_, typename Storage_ = uint8_t>

CUTLASS_HOST_DEVICE int cutlass::SubbyteReference< Element_, Storage_ >::element_offset | ( |  | ) | const
| inline

template<typename Element_, typename Storage_ = uint8_t>

CUTLASS_HOST_DEVICE Element cutlass::SubbyteReference< Element_, Storage_ >::get | ( |  | ) | const
| inline

template<typename Element_, typename Storage_ = uint8_t>

CUTLASS_HOST_DEVICE cutlass::SubbyteReference< Element_, Storage_ >::operator double | ( |  | ) | const
| inline explicit

template<typename Element_, typename Storage_ = uint8_t>

CUTLASS_HOST_DEVICE cutlass::SubbyteReference< Element_, Storage_ >::operator Element | ( |  | ) | const
| inline

template<typename Element_, typename Storage_ = uint8_t>

CUTLASS_HOST_DEVICE cutlass::SubbyteReference< Element_, Storage_ >::operator float | ( |  | ) | const
| inline explicit

template<typename Element_, typename Storage_ = uint8_t>

CUTLASS_HOST_DEVICE cutlass::SubbyteReference< Element_, Storage_ >::operator int | ( |  | ) | const
| inline explicit

template<typename Element_, typename Storage_ = uint8_t>

CUTLASS_HOST_DEVICE cutlass::SubbyteReference< Element_, Storage_ >::operator int64_t | ( |  | ) | const
| inline explicit

template<typename Element_, typename Storage_ = uint8_t>

CUTLASS_HOST_DEVICE cutlass::SubbyteReference< Element_, Storage_ >::operator uint64_t | ( |  | ) | const
| inline explicit

template<typename Element_, typename Storage_ = uint8_t>

CUTLASS_HOST_DEVICE SubbyteReference cutlass::SubbyteReference< Element_, Storage_ >::operator+ | ( | int | offset | ) | const
| inline

template<typename Element_, typename Storage_ = uint8_t>

CUTLASS_HOST_DEVICE SubbyteReference cutlass::SubbyteReference< Element_, Storage_ >::operator+ | ( | long long | offset | ) | const
| inline

template<typename Element_, typename Storage_ = uint8_t>

CUTLASS_HOST_DEVICE SubbyteReference& cutlass::SubbyteReference< Element_, Storage_ >::operator+= | ( | int | offset | ) |
| inline

template<typename Element_, typename Storage_ = uint8_t>

CUTLASS_HOST_DEVICE SubbyteReference& cutlass::SubbyteReference< Element_, Storage_ >::operator+= | ( | long long | offset | ) |
| inline

template<typename Element_, typename Storage_ = uint8_t>

CUTLASS_HOST_DEVICE SubbyteReference cutlass::SubbyteReference< Element_, Storage_ >::operator- | ( | int | offset | ) | const
| inline

template<typename Element_, typename Storage_ = uint8_t>

CUTLASS_HOST_DEVICE ptrdiff_t cutlass::SubbyteReference< Element_, Storage_ >::operator- | ( | SubbyteReference< Element_, Storage_ > | ref | ) | const
| inline

template<typename Element_, typename Storage_ = uint8_t>

CUTLASS_HOST_DEVICE SubbyteReference& cutlass::SubbyteReference< Element_, Storage_ >::operator-= | ( | int | offset | ) |
| inline

template<typename Element_, typename Storage_ = uint8_t>

CUTLASS_HOST_DEVICE SubbyteReference& cutlass::SubbyteReference< Element_, Storage_ >::operator-= | ( | long long | offset | ) |
| inline

template<typename Element_, typename Storage_ = uint8_t>

CUTLASS_HOST_DEVICE SubbyteReference cutlass::SubbyteReference< Element_, Storage_ >::operator-= | ( | long long | offset | ) | const
| inline

template<typename Element_, typename Storage_ = uint8_t>

CUTLASS_HOST_DEVICE SubbyteReference& cutlass::SubbyteReference< Element_, Storage_ >::operator= | ( | Element const & | x | ) |
| inline

template<typename Element_, typename Storage_ = uint8_t>

CUTLASS_HOST_DEVICE SubbyteReference& cutlass::SubbyteReference< Element_, Storage_ >::operator= | ( | SubbyteReference< Element_, Storage_ > const & | x | ) |
| inline

template<typename Element_, typename Storage_ = uint8_t>

CUTLASS_HOST_DEVICE SubbyteReference& cutlass::SubbyteReference< Element_, Storage_ >::operator= | ( | ConstSubbyteReference< Element, Storage > const & | x | ) |
| inline

template<typename Element_, typename Storage_ = uint8_t>

CUTLASS_HOST_DEVICE SubbyteReference& cutlass::SubbyteReference< Element_, Storage_ >::set | ( | Element const & | x | ) |
| inline

template<typename Element_, typename Storage_ = uint8_t>

CUTLASS_HOST_DEVICE StoragePointer cutlass::SubbyteReference< Element_, Storage_ >::storage_pointer | ( |  | ) | const
| inline

The documentation for this class was generated from the following file:

- subbyte_reference.h